/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.49 Revision 1.118
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.49 2009/11/09 19:30:40 ayoy Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.118 2012/02/09 22:58:36 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 12inherit base eutils multilib toolchain-funcs flag-o-matic versionator
16 13
14MY_PV=${PV/_/-}
15MY_P=qt-everywhere-opensource-src-${MY_PV}
16
17HOMEPAGE="http://qt.nokia.com/ http://qt-project.org/"
18SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
19LICENSE="|| ( LGPL-2.1 GPL-3 )"
20
17IUSE="${IUSE} debug pch" 21IUSE="aqua debug pch"
22
23[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] &&
24[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
25 IUSE+=" +exceptions"
26
27if version_is_at_least 4.7.99999999; then
28 IUSE+=" c++0x qpa"
29fi
30
31DEPEND="dev-util/pkgconfig"
18RDEPEND=" 32RDEPEND="
19 !<x11-libs/qt-assistant-${PV} 33 !<x11-libs/qt-assistant-${PV}
20 !>x11-libs/qt-assistant-${PV}-r9999 34 !>x11-libs/qt-assistant-${PV}-r9999
21 !<x11-libs/qt-core-${PV} 35 !<x11-libs/qt-core-${PV}
22 !>x11-libs/qt-core-${PV}-r9999 36 !>x11-libs/qt-core-${PV}-r9999
23 !<x11-libs/qt-dbus-${PV} 37 !<x11-libs/qt-dbus-${PV}
24 !>x11-libs/qt-dbus-${PV}-r9999 38 !>x11-libs/qt-dbus-${PV}-r9999
39 !<x11-libs/qt-declarative-${PV}
40 !>x11-libs/qt-declarative-${PV}-r9999
25 !<x11-libs/qt-demo-${PV} 41 !<x11-libs/qt-demo-${PV}
26 !>x11-libs/qt-demo-${PV}-r9999 42 !>x11-libs/qt-demo-${PV}-r9999
27 !<x11-libs/qt-gui-${PV} 43 !<x11-libs/qt-gui-${PV}
28 !>x11-libs/qt-gui-${PV}-r9999 44 !>x11-libs/qt-gui-${PV}-r9999
45 !<x11-libs/qt-multimedia-${PV}
46 !>x11-libs/qt-multimedia-${PV}-r9999
29 !<x11-libs/qt-opengl-${PV} 47 !<x11-libs/qt-opengl-${PV}
30 !>x11-libs/qt-opengl-${PV}-r9999 48 !>x11-libs/qt-opengl-${PV}-r9999
31 !<x11-libs/qt-phonon-${PV} 49 !<x11-libs/qt-phonon-${PV}
32 !>x11-libs/qt-phonon-${PV}-r9999 50 !>x11-libs/qt-phonon-${PV}-r9999
33 !<x11-libs/qt-qt3support-${PV} 51 !<x11-libs/qt-qt3support-${PV}
43 !<x11-libs/qt-webkit-${PV} 61 !<x11-libs/qt-webkit-${PV}
44 !>x11-libs/qt-webkit-${PV}-r9999 62 !>x11-libs/qt-webkit-${PV}-r9999
45 !<x11-libs/qt-xmlpatterns-${PV} 63 !<x11-libs/qt-xmlpatterns-${PV}
46 !>x11-libs/qt-xmlpatterns-${PV}-r9999 64 !>x11-libs/qt-xmlpatterns-${PV}-r9999
47" 65"
48case "${PV}" in
49 4.?.?_rc* | 4.?.?_beta* )
50 SRCTYPE="${SRCTYPE:-opensource-src}"
51 MY_PV="${PV/_/-}"
52 ;;
53 *)
54 SRCTYPE="${SRCTYPE:-opensource-src}"
55 MY_PV="${PV}"
56 ;;
57esac
58 66
59if version_is_at_least 4.5.99999999 ${PV} ; then
60 MY_P="qt-everywhere-${SRCTYPE}-${MY_PV}"
61else
62 MY_P="qt-x11-${SRCTYPE}-${MY_PV}"
63fi
64S=${WORKDIR}/${MY_P} 67S=${WORKDIR}/${MY_P}
65 68
66HOMEPAGE="http://qt.nokia.com/"
67if version_is_at_least 4.5.3 ${PV} ; then
68 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
69else
70 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.bz2"
71fi
72
73case "${PV}" in
74 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
75 *) ;;
76esac
77
78if version_is_at_least 4.5 ${PV} ; then
79 LICENSE="|| ( LGPL-2.1 GPL-3 )"
80fi
81
82# @FUNCTION: qt4-build_pkg_setup 69# @FUNCTION: qt4-build_pkg_setup
83# @DESCRIPTION: 70# @DESCRIPTION:
84# Sets up installation directories, PLATFORM, PATH, and LD_LIBRARY_PATH 71# Sets up PATH and LD_LIBRARY_PATH.
85qt4-build_pkg_setup() { 72qt4-build_pkg_setup() {
86 # EAPI=2 ebuilds set use-deps, others need this: 73 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
87 if [[ $EAPI != 2 ]]; then 74
88 # Make sure debug setting corresponds with qt-core (bug 258512) 75 # Protect users by not allowing downgrades between releases
89 if [[ $PN != "qt-core" ]]; then 76 # Downgrading revisions within the same release should be allowed
90 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} 77 if has_version '>'${CATEGORY}/${P}-r9999; then
91 ~x11-libs/qt-core-${PV} debug" 78 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
79 eerror "Sanity check to keep you from breaking your system:"
80 eerror " Downgrading Qt is completely unsupported and will break your system!"
81 die "aborting to save your system"
82 else
83 ewarn "Downgrading Qt is completely unsupported and will break your system!"
92 fi 84 fi
85 fi
93 86
94 # Check USE requirements 87 if [[ ${PN} == "qt-webkit" ]]; then
95 qt4-build_check_use 88 eshopts_push -s extglob
89 if is-flagq '-g?(gdb)?([1-9])'; then
90 echo
91 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
92 ewarn "You may experience really long compilation times and/or increased memory usage."
93 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
94 ewarn "For more info check out bug #307861"
95 echo
96 fi 96 fi
97 eshopts_pop
98 fi
97 99
98 PATH="${S}/bin:${PATH}" 100 PATH="${S}/bin${PATH:+:}${PATH}"
101 if [[ ${CHOST} != *-darwin* ]]; then
99 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}" 102 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
103 else
104 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
105 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
106 # platform detection. Note: needs to come before any directories to
107 # avoid extract failure.
108 [[ ${CHOST} == *-apple-darwin* ]] && \
109 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
110 ${QT4_EXTRACT_DIRECTORIES}"
111 fi
100 112
113 # Make sure ebuilds use the required EAPI
114 if [[ ${EAPI} != [234] ]]; then
115 eerror "The qt4-build eclass requires EAPI 2,3 or 4 but this ebuild is using"
116 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
117 eerror "fixed. Using qt4-build eclass without EAPI 2,3 or 4 will fail."
118 die "qt4-build eclass requires EAPI 2,3 or 4"
119 fi
120
101 if ! version_is_at_least 4.1 $(gcc-version) ; then 121 if ! version_is_at_least 4.1 $(gcc-version); then
102 ewarn "Using a GCC version lower than 4.1 is not supported!" 122 ewarn "Using a GCC version lower than 4.1 is not supported!"
103 echo
104 ebeep 3
105 fi 123 fi
106} 124}
107 125
108# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 126# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
109# @DESCRIPTION: 127# @DESCRIPTION:
110# Arguments for build_target_directories. Takes the directories, in which the 128# Arguments for build_target_directories. Takes the directories in which the
111# code should be compiled. This is a space-separated list 129# code should be compiled. This is a space-separated list.
112 130
113# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 131# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
114# @DESCRIPTION: 132# @DESCRIPTION:
115# Space separated list including the directories that will be extracted from Qt 133# Space-separated list including the directories that will be extracted from
116# tarball 134# Qt tarball.
117 135
118# @FUNCTION: qt4-build_src_unpack 136# @FUNCTION: qt4-build_src_unpack
119# @DESCRIPTION: 137# @DESCRIPTION:
120# Unpacks the sources 138# Unpacks the sources.
121qt4-build_src_unpack() { 139qt4-build_src_unpack() {
122 setqtenv 140 setqtenv
123 local target targets licenses tar_pkg tar_args 141
124 if version_is_at_least 4.5 ${PV} ; then 142 local tarball="${MY_P}.tar.gz" target= targets=
125 licenses="LICENSE.GPL3 LICENSE.LGPL" 143 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
126 else
127 licenses="LICENSE.GPL2 LICENSE.GPL3"
128 fi
129 for target in configure ${licenses} projects.pro \
130 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 144 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
131 ${QT4_EXTRACT_DIRECTORIES}; do 145 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
146 do
132 targets="${targets} ${MY_P}/${target}" 147 targets+="${MY_P}/${target} "
133 done 148 done
134 149
135 tar_pkg=${MY_P}.tar.bz2 150 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
136 tar_args="xjpf" 151 tar -xzf "${DISTDIR}/${tarball}" ${targets}
137 if version_is_at_least 4.5.3 ${PV} ; then 152 eend $? || die "failed to unpack"
138 tar_pkg=${tar_pkg/bz2/gz}
139 tar_args="xzpf"
140 fi
141
142 echo tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
143 tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
144
145 case "${PV}" in
146 4.4.?)
147 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
148 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
149 ;;
150 esac
151
152 # Be backwards compatible for now
153 if [[ $EAPI != 2 ]]; then
154 qt4-build_src_prepare
155 fi
156} 153}
157 154
158# @ECLASS-VARIABLE: PATCHES 155# @ECLASS-VARIABLE: PATCHES
156# @DEFAULT_UNSET
159# @DESCRIPTION: 157# @DESCRIPTION:
160# In case you have patches to apply, specify them in PATCHES variable. Make sure 158# PATCHES array variable containing all various patches to be applied.
161# to specify the full path. This variable is necessary for src_prepare phase. 159# This variable is expected to be defined in global scope of ebuild.
162# example: 160# Make sure to specify the full path. This variable is utilised in
163# PATCHES="${FILESDIR}"/mypatch.patch 161# src_unpack/src_prepare phase, based on EAPI.
164# ${FILESDIR}"/mypatch2.patch"
165# 162#
163# @CODE
164# PATCHES=( "${FILESDIR}/mypatch.patch"
165# "${FILESDIR}/patches_folder/" )
166# @CODE
166 167
167# @FUNCTION: qt4-build_src_prepare 168# @FUNCTION: qt4-build_src_prepare
168# @DESCRIPTION: 169# @DESCRIPTION:
169# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 170# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
170# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 171# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
171qt4-build_src_prepare() { 172qt4-build_src_prepare() {
172 setqtenv 173 setqtenv
173 cd "${S}" 174 cd "${S}"
174 175
176 if version_is_at_least "4.7"; then
177 # fix libX11 dependency on non X packages
178 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
179 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
180
181 qt_assistant_cleanup
182 fi
183
184 if use aqua; then
185 # provide a proper macx-g++-64
186 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
187
188 sed -e '/^CONFIG/s:app_bundle::' \
189 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
190 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
191 fi
192
175 if [[ ${PN} != qt-core ]]; then 193 if [[ ${PN} != qt-core ]]; then
176 skip_qmake_build_patch 194 skip_qmake_build
177 skip_project_generation_patch 195 skip_project_generation
178 symlink_binaries_to_buildtree 196 symlink_binaries_to_buildtree
179 fi 197 fi
180 198
199 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then
200 # qmake bus errors with -O2 but -O3 works
201 replace-flags -O2 -O3
202 fi
203
181 # Bug 178652 204 # Bug 178652
182 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then 205 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
183 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 206 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
184 append-flags -fno-gcse 207 append-flags -fno-gcse
185 fi 208 fi
186 209
210 if use_if_iuse c++0x; then
211 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
212 ewarn "this is an official standard, some of the reverse dependencies"
213 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
214 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
215 ewarn "disabled."
216 append-flags -std=c++0x
217 fi
218
187 # Unsupported old gcc versions - hardened needs this :( 219 # Unsupported old gcc versions - hardened needs this :(
188 if [[ $(gcc-major-version) -lt "4" ]] ; then 220 if [[ $(gcc-major-version) -lt 4 ]] ; then
189 ewarn "Appending -fno-stack-protector to CXXFLAGS" 221 ewarn "Appending -fno-stack-protector to CXXFLAGS"
190 append-cxxflags -fno-stack-protector 222 append-cxxflags -fno-stack-protector
191 # Bug 253127 223 # Bug 253127
192 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 224 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
193 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 225 -i mkspecs/common/g++.conf || die
194 fi 226 fi
195 227
196 # Bug 261632 228 # Bug 261632
197 if use ppc64; then 229 if use ppc64; then
198 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 230 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
199 append-flags -mminimal-toc 231 append-flags -mminimal-toc
200 fi 232 fi
201 233
234 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
235 sed -e "/^SYSTEM_VARIABLES=/i \
236 CC='$(tc-getCC)'\n\
237 CXX='$(tc-getCXX)'\n\
238 CFLAGS='${CFLAGS}'\n\
239 CXXFLAGS='${CXXFLAGS}'\n\
240 LDFLAGS='${LDFLAGS}'\n" \
241 -i configure \
242 || die "sed SYSTEM_VARIABLES failed"
243
244 # Respect CC, CXX, LINK and *FLAGS in config.tests
245 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
246 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
247 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
248 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
249 || die "sed config.tests failed"
250
251 # Strip predefined CFLAGS from mkspecs (bug 312689)
252 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
253
202 # Bug 172219 254 # Bug 172219
255 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
256
257 if [[ ${CHOST} == *-darwin* ]]; then
258 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
259 # crippled (by design) :/
260 sed \
203 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 261 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
204 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 262 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
205 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 263 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
206 -e "s:X11R6/::" \ 264 -e "s:-arch\s\w*::g" \
207 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 265 -i mkspecs/common/mac-g++.conf \
266 || die "sed mkspecs/common/mac-g++.conf failed"
208 267
209 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 268 # Fix configure's -arch settings that appear in qmake/Makefile and also
210 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 269 # fix arch handling (automagically duplicates our -arch arg and breaks
211 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 270 # pch). Additionally disable Xarch support.
212 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 271 sed \
272 -e "s:-arch i386::" \
273 -e "s:-arch ppc::" \
274 -e "s:-arch x86_64::" \
275 -e "s:-arch ppc64::" \
276 -e "s:-arch \$i::" \
277 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
278 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
279 -e "s:-Xarch_x86_64::g" \
280 -e "s:-Xarch_ppc64::g" \
281 -i configure mkspecs/common/mac-g++.conf \
282 || die "sed -arch/-Xarch failed"
283
284 # On Snow Leopard don't fall back to 10.5 deployment target.
285 if [[ ${CHOST} == *-apple-darwin10 ]] ; then
286 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
287 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
288 -i configure mkspecs/common/mac-g++.conf \
289 || die "sed deployment target failed"
290 fi
291 fi
292
293 # this one is needed for all systems with a separate -liconv, apart from
294 # Darwin, for which the sources already cater for -liconv
295 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then
296 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
297 -i config.tests/unix/iconv/iconv.pro \
298 || die "sed iconv.pro failed"
299 fi
300
301 # we need some patches for Solaris
302 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
303 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
304 # use GCC over SunStudio
305 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
306 # do not flirt with non-Prefix stuff, we're quite possessive
307 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
308 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
213 309
214 base_src_prepare 310 base_src_prepare
215} 311}
216 312
217# @FUNCTION: qt4-build_src_configure 313# @FUNCTION: qt4-build_src_configure
219# Default configure phase 315# Default configure phase
220qt4-build_src_configure() { 316qt4-build_src_configure() {
221 setqtenv 317 setqtenv
222 myconf="$(standard_configure_options) ${myconf}" 318 myconf="$(standard_configure_options) ${myconf}"
223 319
320 # this one is needed for all systems with a separate -liconv, apart from
321 # Darwin, for which the sources already cater for -liconv
322 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \
323 myconf+=" -liconv"
324
325 if use_if_iuse glib; then
326 # use -I, -L and -l from configure
327 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
328 # avoid the -pthread argument
329 myconf+=" ${glibflags//-pthread}"
330 unset glibflags
331 fi
332
333 if use_if_iuse qpa; then
334 ewarn
335 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
336 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
337 ewarn "disable it before reporting any bugs related to this useflag."
338 ewarn
339 myconf+=" -qpa"
340 fi
341
342 if use aqua ; then
343 # On (snow) leopard use the new (frameworked) cocoa code.
344 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then
345 myconf+=" -cocoa -framework"
346
347 # We are crazy and build cocoa + qt3support :-)
348 if use qt3support; then
349 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
350 -i configure || die
351 fi
352
353 # We need the source's headers, not the installed ones.
354 myconf+=" -I${S}/include"
355
356 # Add hint for the framework location.
357 myconf+=" -F${QTLIBDIR}"
358 fi
359 else
360 # freetype2 include dir is non-standard, thus include it on configure
361 # use -I from configure
362 myconf+=" $(pkg-config --cflags freetype2)"
363 fi
364
224 echo ./configure ${myconf} 365 echo ./configure ${myconf}
225 ./configure ${myconf} || die "./configure failed" 366 ./configure ${myconf} || die "./configure failed"
226 myconf="" 367 myconf=""
368
369 prepare_directories ${QT4_TARGET_DIRECTORIES}
227} 370}
228 371
229# @FUNCTION: qt4-build_src_compile 372# @FUNCTION: qt4-build_src_compile
373# @DESCRIPTION:
230# @DESCRIPTION: Actual compile phase 374# Actual compile phase
231qt4-build_src_compile() { 375qt4-build_src_compile() {
232 setqtenv 376 setqtenv
233 # Be backwards compatible for now
234 if [[ $EAPI != 2 ]]; then
235 qt4-build_src_configure
236 fi
237 377
238 build_directories "${QT4_TARGET_DIRECTORIES}" 378 build_directories ${QT4_TARGET_DIRECTORIES}
379}
380
381# @FUNCTION: qt4-build_src_test
382# @DESCRIPTION:
383# Runs tests only in target directories.
384qt4-build_src_test() {
385 # QtMultimedia does not have any test suite (bug #332299)
386 [[ ${PN} == "qt-multimedia" ]] && return
387
388 for dir in ${QT4_TARGET_DIRECTORIES}; do
389 emake -j1 check -C ${dir}
390 done
391}
392
393# @FUNCTION: fix_includes
394# @DESCRIPTION:
395# For MacOS X we need to add some symlinks when frameworks are
396# being used, to avoid complications with some more or less stupid packages.
397fix_includes() {
398 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then
399 # Some packages tend to include <Qt/...>
400 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
401
402 # Fake normal headers when frameworks are installed... eases life later on
403 local dest f h
404 for frw in "${D}${QTLIBDIR}"/*.framework; do
405 [[ -e "${frw}"/Headers ]] || continue
406 f=$(basename ${frw})
407 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
408 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
409
410 # Link normal headers as well.
411 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
412 h=$(basename ${hdr})
413 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
414 done
415 done
416 fi
239} 417}
240 418
241# @FUNCTION: qt4-build_src_install 419# @FUNCTION: qt4-build_src_install
242# @DESCRIPTION: 420# @DESCRIPTION:
243# Perform the actual installation including some library fixes. 421# Perform the actual installation including some library fixes.
244qt4-build_src_install() { 422qt4-build_src_install() {
423 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
245 setqtenv 424 setqtenv
425
246 install_directories "${QT4_TARGET_DIRECTORIES}" 426 install_directories ${QT4_TARGET_DIRECTORIES}
247 install_qconfigs 427 install_qconfigs
248 fix_library_files 428 fix_library_files
429 fix_includes
430
431 # remove .la files since we are building only shared Qt libraries
432 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
249} 433}
250 434
251# @FUNCTION: setqtenv 435# @FUNCTION: setqtenv
436# @INTERNAL
252setqtenv() { 437setqtenv() {
253 # Set up installation directories 438 # Set up installation directories
254 QTBASEDIR=/usr/$(get_libdir)/qt4
255 QTPREFIXDIR=/usr 439 QTPREFIXDIR=${EPREFIX}/usr
256 QTBINDIR=/usr/bin 440 QTBINDIR=${EPREFIX}/usr/bin
257 QTLIBDIR=/usr/$(get_libdir)/qt4 441 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
258 QMAKE_LIBDIR_QT=${QTLIBDIR}
259 QTPCDIR=/usr/$(get_libdir)/pkgconfig 442 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
260 QTDATADIR=/usr/share/qt4
261 QTDOCDIR=/usr/share/doc/qt-${PV} 443 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
262 QTHEADERDIR=/usr/include/qt4 444 QTHEADERDIR=${EPREFIX}/usr/include/qt4
263 QTPLUGINDIR=${QTLIBDIR}/plugins 445 QTPLUGINDIR=${QTLIBDIR}/plugins
264 QTSYSCONFDIR=/etc/qt4 446 QTIMPORTDIR=${QTLIBDIR}/imports
447 QTDATADIR=${EPREFIX}/usr/share/qt4
265 QTTRANSDIR=${QTDATADIR}/translations 448 QTTRANSDIR=${QTDATADIR}/translations
449 QTSYSCONFDIR=${EPREFIX}/etc/qt4
266 QTEXAMPLESDIR=${QTDATADIR}/examples 450 QTEXAMPLESDIR=${QTDATADIR}/examples
267 QTDEMOSDIR=${QTDATADIR}/demos 451 QTDEMOSDIR=${QTDATADIR}/demos
452 QMAKE_LIBDIR_QT=${QTLIBDIR}
268 QT_INSTALL_PREFIX=/usr/$(get_libdir)/qt4 453 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
454
269 PLATFORM=$(qt_mkspecs_dir) 455 PLATFORM=$(qt_mkspecs_dir)
270 456
271 unset QMAKESPEC 457 unset QMAKESPEC
272} 458}
273 459
274# @FUNCTION: standard_configure_options 460# @FUNCTION: standard_configure_options
461# @INTERNAL
275# @DESCRIPTION: 462# @DESCRIPTION:
276# Sets up some standard configure options, like libdir (if necessary), whether 463# Sets up some standard configure options, like libdir (if necessary), whether
277# debug info is wanted or not. 464# debug info is wanted or not.
278standard_configure_options() { 465standard_configure_options() {
279 local myconf="" 466 local myconf="-prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
467 -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR} -plugindir ${QTPLUGINDIR}
468 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
469 -datadir ${QTDATADIR} -translationdir ${QTTRANSDIR} -sysconfdir ${QTSYSCONFDIR}
470 -examplesdir ${QTEXAMPLESDIR} -demosdir ${QTDEMOSDIR}
471 -opensource -confirm-license -shared -fast -largefile -stl -verbose
472 -platform $(qt_mkspecs_dir) -nomake examples -nomake demos"
280 473
281 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)" 474 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
282 475
283 # Disable visibility explicitly if gcc version isn't 4 476 # debug/release
284 if [[ "$(gcc-major-version)" -lt "4" ]]; then
285 myconf="${myconf} -no-reduce-exports"
286 fi
287
288 # precompiled headers doesn't work on hardened, where the flag is masked.
289 if use pch; then 477 if use debug; then
290 myconf="${myconf} -pch" 478 myconf+=" -debug"
291 else 479 else
292 myconf="${myconf} -no-pch" 480 myconf+=" -release"
293 fi 481 fi
294
295 if use debug; then
296 myconf="${myconf} -debug -no-separate-debug-info" 482 myconf+=" -no-separate-debug-info"
297 else 483
298 myconf="${myconf} -release -no-separate-debug-info" 484 # exceptions USE flag
299 fi 485 local exceptions="-exceptions"
486 in_iuse exceptions && exceptions="$(qt_use exceptions)"
487 myconf+=" ${exceptions}"
488
489 # disable RPATH on Qt >= 4.8 (bug 380415)
490 version_is_at_least 4.8 && myconf+=" -no-rpath"
491
492 # precompiled headers don't work on hardened, where the flag is masked
493 myconf+=" $(qt_use pch)"
494
495 # -reduce-relocations
496 # This flag seems to introduce major breakage to applications,
497 # mostly to be seen as a core dump with the message "QPixmap: Must
498 # construct a QApplication before a QPaintDevice" on Solaris.
499 # -- Daniel Vergien
500 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
501
502 use aqua && myconf+=" -no-framework"
300 503
301 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 504 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
302 # $(tc-arch). Therefore we convert it to supported values. 505 # $(tc-arch). Therefore we convert it to supported values.
303 case "$(tc-arch)" in 506 case "$(tc-arch)" in
304 amd64) myconf="${myconf} -arch x86_64" ;; 507 amd64|x64-*) myconf+=" -arch x86_64" ;;
508 ppc-macos) myconf+=" -arch ppc" ;;
305 ppc|ppc64) myconf="${myconf} -arch powerpc" ;; 509 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
510 sparc|sparc-*|sparc64-*) myconf+=" -arch sparc" ;;
511 x86-macos) myconf+=" -arch x86" ;;
306 x86|x86-*) myconf="${myconf} -arch i386" ;; 512 x86|x86-*) myconf+=" -arch i386" ;;
307 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch $(tc-arch)" ;; 513 alpha|arm|ia64|mips|s390) myconf+=" -arch $(tc-arch)" ;;
308 hppa|sh) myconf="${myconf} -arch generic" ;; 514 hppa|sh) myconf+=" -arch generic" ;;
309 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 515 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
310 esac 516 esac
311 517
312 # 4.6: build qt-core with exceptions or qt-xmlpatterns won't build
313 local exceptions=
314 case "${PV}" in
315 4.6.*)
316 if [[ ${PN} != "qt-core" ]] && [[ ${PN} != "qt-xmlpatterns" ]]; then
317 exceptions="-no-exceptions"
318 fi
319 ;;
320 *)
321 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
322 ;;
323 esac
324
325 myconf="${myconf} -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license -no-rpath
326 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
327 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
328 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
329 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
330 -demosdir ${QTDEMOSDIR} -silent -fast
331 ${exceptions}
332 -reduce-relocations -nomake examples -nomake demos"
333
334 # Make eclass >= 4.5.x ready
335 case "${MY_PV}" in
336 4.5.* | 4.6.* )
337 myconf="${myconf} -opensource"
338 ;;
339 esac
340
341 echo "${myconf}" 518 echo "${myconf}"
342} 519}
520
521# @FUNCTION: prepare_directories
522# @USAGE: < directories >
523# @INTERNAL
524# @DESCRIPTION:
525# Generates Makefiles for the given list of directories.
526prepare_directories() {
527 for x in "$@"; do
528 pushd "${S}"/${x} >/dev/null || die
529 einfo "Running qmake in: ${x}"
530 # avoid running over the maximum argument number, bug #299810
531 {
532 echo "${S}"/mkspecs/common/*.conf
533 find "${S}" -name '*.pr[io]'
534 } | xargs sed -i \
535 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
536 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
537 || die
538 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
539 popd >/dev/null || die
540 done
541}
542
343 543
344# @FUNCTION: build_directories 544# @FUNCTION: build_directories
345# @USAGE: < directories > 545# @USAGE: < directories >
546# @INTERNAL
346# @DESCRIPTION: 547# @DESCRIPTION:
347# Compiles the code in $QT4_TARGET_DIRECTORIES 548# Compiles the code in the given list of directories.
348build_directories() { 549build_directories() {
349 local dirs="$@"
350 for x in ${dirs}; do 550 for x in "$@"; do
351 cd "${S}"/${x} 551 pushd "${S}"/${x} >/dev/null || die
352 sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:/usr/$(get_libdir)/qt4:g" $(find "${S}" -name '*.pr[io]') "${S}"/mkspecs/common/linux.conf || die 552 emake CC="$(tc-getCC)" \
353 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 553 CXX="$(tc-getCXX)" \
354 emake CC="@echo compiling \$< && $(tc-getCC)" \
355 CXX="@echo compiling \$< && $(tc-getCXX)" \
356 LINK="@echo linking \$@ && $(tc-getCXX)" || die "emake failed" 554 LINK="$(tc-getCXX)" || die "emake failed"
555 popd >/dev/null || die
357 done 556 done
358} 557}
359 558
360# @FUNCTION: install_directories 559# @FUNCTION: install_directories
361# @USAGE: < directories > 560# @USAGE: < directories >
561# @INTERNAL
362# @DESCRIPTION: 562# @DESCRIPTION:
363# run emake install in the given directories, which are separated by spaces 563# Runs emake install in the given directories, which are separated by spaces.
364install_directories() { 564install_directories() {
365 local dirs="$@"
366 for x in ${dirs}; do 565 for x in "$@"; do
367 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 566 pushd "${S}"/${x} >/dev/null || die
368 emake INSTALL_ROOT="${D}" install || die "emake install failed" 567 emake INSTALL_ROOT="${D}" install || die "emake install failed"
369 popd >/dev/null || die "Can't popd from ${S}/${x}" 568 popd >/dev/null || die
370 done 569 done
371} 570}
372 571
373# @ECLASS-VARIABLE: QCONFIG_ADD 572# @ECLASS-VARIABLE: QCONFIG_ADD
374# @DESCRIPTION: 573# @DESCRIPTION:
375# List options that need to be added to QT_CONFIG in qconfig.pri 574# List options that need to be added to QT_CONFIG in qconfig.pri
376QCONFIG_ADD="${QCONFIG_ADD:-}" 575: ${QCONFIG_ADD:=}
377 576
378# @ECLASS-VARIABLE: QCONFIG_REMOVE 577# @ECLASS-VARIABLE: QCONFIG_REMOVE
379# @DESCRIPTION: 578# @DESCRIPTION:
380# List options that need to be removed from QT_CONFIG in qconfig.pri 579# List options that need to be removed from QT_CONFIG in qconfig.pri
381QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 580: ${QCONFIG_REMOVE:=}
382 581
383# @ECLASS-VARIABLE: QCONFIG_DEFINE 582# @ECLASS-VARIABLE: QCONFIG_DEFINE
384# @DESCRIPTION: 583# @DESCRIPTION:
385# List variables that should be defined at the top of QtCore/qconfig.h 584# List variables that should be defined at the top of QtCore/qconfig.h
386QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 585: ${QCONFIG_DEFINE:=}
387 586
388# @FUNCTION: install_qconfigs 587# @FUNCTION: install_qconfigs
588# @INTERNAL
589# @DESCRIPTION:
389# @DESCRIPTION: Install gentoo-specific mkspecs configurations 590# Install gentoo-specific mkspecs configurations.
390install_qconfigs() { 591install_qconfigs() {
391 local x 592 local x
392 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 593 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
393 for x in QCONFIG_ADD QCONFIG_REMOVE; do 594 for x in QCONFIG_ADD QCONFIG_REMOVE; do
394 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 595 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
395 done 596 done
396 insinto ${QTDATADIR}/mkspecs/gentoo 597 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
397 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 598 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
398 fi 599 fi
399 600
400 if [[ -n ${QCONFIG_DEFINE} ]]; then 601 if [[ -n ${QCONFIG_DEFINE} ]]; then
401 for x in ${QCONFIG_DEFINE}; do 602 for x in ${QCONFIG_DEFINE}; do
402 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 603 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
403 done 604 done
404 insinto ${QTHEADERDIR}/Gentoo 605 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
405 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 606 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
406 fi 607 fi
407} 608}
408 609
409# @FUNCTION: generate_qconfigs 610# @FUNCTION: generate_qconfigs
410# @DESCRIPTION: Generates gentoo-specific configurations 611# @INTERNAL
612# @DESCRIPTION:
613# Generates gentoo-specific qconfig.{h,pri}.
411generate_qconfigs() { 614generate_qconfigs() {
412 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 615 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then
413 local x qconfig_add qconfig_remove qconfig_new 616 local x qconfig_add qconfig_remove qconfig_new
414 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 617 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
415 [[ -f ${x} ]] || continue 618 [[ -f ${x} ]] || continue
416 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 619 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
417 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 620 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
418 done 621 done
419 622
420 # these error checks do not use die because dying in pkg_post{inst,rm} 623 # these error checks do not use die because dying in pkg_post{inst,rm}
421 # just makes things worse. 624 # just makes things worse.
422 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 625 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
429 632
430 # generate list of QT_CONFIG entries from the existing list 633 # generate list of QT_CONFIG entries from the existing list
431 # including qconfig_add and excluding qconfig_remove 634 # including qconfig_add and excluding qconfig_remove
432 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 635 for x in $(sed -n 's/^QT_CONFIG +=//p' \
433 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 636 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
434 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 637 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
435 done 638 done
436 639
437 # replace the existing QT_CONFIG list with qconfig_new 640 # replace the existing QT_CONFIG list with qconfig_new
438 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 641 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
439 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 642 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
463 fi 666 fi
464 fi 667 fi
465} 668}
466 669
467# @FUNCTION: qt4-build_pkg_postrm 670# @FUNCTION: qt4-build_pkg_postrm
671# @DESCRIPTION:
468# @DESCRIPTION: Generate configurations when the package is completely removed 672# Regenerate configuration when the package is completely removed.
469qt4-build_pkg_postrm() { 673qt4-build_pkg_postrm() {
470 generate_qconfigs 674 generate_qconfigs
471} 675}
472 676
473# @FUNCTION: qt4-build_pkg_postinst 677# @FUNCTION: qt4-build_pkg_postinst
678# @DESCRIPTION:
474# @DESCRIPTION: Generate configuration, plus throws a message about possible 679# Regenerate configuration, plus throw a message about possible
475# breakages and proposed solutions. 680# breakages and proposed solutions.
476qt4-build_pkg_postinst() { 681qt4-build_pkg_postinst() {
477 generate_qconfigs 682 generate_qconfigs
478 echo
479 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
480 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
481 ewarn "should recompile the packages providing these plugins. Also, make sure you"
482 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
483 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
484 ewarn
485 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
486 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
487 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
488 ewarn "configuration."
489 ewarn
490 ewarn "For more information, see http://doc.trolltech.com/${PV%.*}/plugins-howto.html"
491 echo
492} 683}
493 684
494# @FUNCTION: skip_qmake_build_patch 685# @FUNCTION: skip_qmake_build
686# @INTERNAL
495# @DESCRIPTION: 687# @DESCRIPTION:
496# Don't need to build qmake, as it's already installed from qt-core 688# Patches configure to skip qmake compilation, as it's already installed by qt-core.
497skip_qmake_build_patch() { 689skip_qmake_build() {
498 # Don't need to build qmake, as it's already installed from qt-core
499 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 690 sed -i -e "s:if true:if false:g" "${S}"/configure || die
500} 691}
501 692
502# @FUNCTION: skip_project_generation_patch 693# @FUNCTION: skip_project_generation
694# @INTERNAL
503# @DESCRIPTION: 695# @DESCRIPTION:
504# Exit the script early by throwing in an exit before all of the .pro files are scanned 696# Exit the script early by throwing in an exit before all of the .pro files are scanned.
505skip_project_generation_patch() { 697skip_project_generation() {
506 # Exit the script early by throwing in an exit before all of the .pro files are scanned
507 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 698 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
508 -i "${S}"/configure || die "Sed failed"
509} 699}
510 700
511# @FUNCTION: symlink_binaries_to_buildtree 701# @FUNCTION: symlink_binaries_to_buildtree
702# @INTERNAL
512# @DESCRIPTION: 703# @DESCRIPTION:
513# Symlink generated binaries to buildtree so they can be used during compilation 704# Symlinks generated binaries to buildtree, so they can be used during compilation time.
514# time
515symlink_binaries_to_buildtree() { 705symlink_binaries_to_buildtree() {
516 for bin in qmake moc uic rcc; do 706 for bin in qmake moc uic rcc; do
517 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 707 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
518 done 708 done
519} 709}
520 710
521# @FUNCTION: fix_library_files 711# @FUNCTION: fix_library_files
712# @INTERNAL
522# @DESCRIPTION: 713# @DESCRIPTION:
523# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 714# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
524# moves the *.pc-files into the pkgconfig directory 715# moves the *.pc files into the pkgconfig directory.
525fix_library_files() { 716fix_library_files() {
717 local libfile
526 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 718 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
527 if [[ -e ${libfile} ]]; then 719 if [[ -e ${libfile} ]]; then
528 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 720 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
529 fi 721 fi
530 done 722 done
531 723
532 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 724 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
533 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 725 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
534 if [[ -e ${libfile} ]]; then 726 if [[ -e ${libfile} ]]; then
535 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 727 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
536 728
537 # Move .pc files into the pkgconfig directory 729 # Move .pc files into the pkgconfig directory
538 dodir ${QTPCDIR} 730 dodir ${QTPCDIR#${EPREFIX}}
539 mv ${libfile} "${D}"/${QTPCDIR}/ \ 731 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
540 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
541 fi 732 fi
542 done 733 done
543 734
544 # Don't install an empty directory 735 # Don't install an empty directory
545 rmdir "${D}"/${QTLIBDIR}/pkgconfig 736 rmdir "${D}"/${QTLIBDIR}/pkgconfig
546} 737}
547 738
548# @FUNCTION: qt_use 739# @FUNCTION: qt_use
549# @USAGE: < flag > [ feature ] [ enableval ] 740# @USAGE: < flag > [ feature ] [ enableval ]
550# @DESCRIPTION: 741# @DESCRIPTION:
551# This will echo "${enableval}-${feature}" if <flag> is enabled, or 742# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
552# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 743# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
553# will be used for that. If [enableval] is not specified, it omits the 744# will be used for that. If [enableval] is not specified, it omits the
554# assignment-part 745# "-${enableval}" part.
555qt_use() { 746qt_use() {
556 local flag="${1}" 747 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
557 local feature="${1}"
558 local enableval=
559
560 [[ -n ${2} ]] && feature=${2}
561 [[ -n ${3} ]] && enableval="-${3}"
562
563 if use ${flag}; then
564 echo "${enableval}-${feature}"
565 else
566 echo "-no-${feature}"
567 fi
568}
569
570# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK
571# @DESCRIPTION:
572# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use
573# (eutils.eclass), line per line.
574#
575# Example:
576# @CODE
577# pkg_setup() {
578# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
579# ~x11-libs/qt-gui-${PV} qt3support"
580# qt4-build_check_use
581# }
582# @CODE
583
584# Run built_with_use on each flag and print appropriate error messages if any
585# flags are missing
586
587_qt_built_with_use() {
588 local missing opt pkg flag flags
589
590 if [[ ${1} = "--missing" ]]; then
591 missing="${1} ${2}" && shift 2
592 fi
593 if [[ ${1:0:1} = "-" ]]; then
594 opt=${1} && shift
595 fi
596
597 pkg=${1} && shift
598
599 for flag in "${@}"; do
600 flags="${flags} ${flag}"
601 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
602 flags="${flags}*"
603 else
604 [[ ${opt} = "-o" ]] && return 0
605 fi
606 done
607 if [[ "${flags# }" = "${@}" ]]; then
608 return 0
609 fi
610 if [[ ${opt} = "-o" ]]; then
611 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
612 else
613 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
614 fi
615 return 1
616}
617
618# @FUNCTION: qt4-build_check_use
619# @DESCRIPTION:
620# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
621# USE flags listed.
622#
623# If any of the required USE flags are missing, an eerror will be printed for
624# each package with missing USE flags.
625qt4-build_check_use() {
626 local line missing
627 while read line; do
628 [[ -z ${line} ]] && continue
629 if ! _qt_built_with_use ${line}; then
630 missing=true
631 fi
632 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
633 if [[ -n ${missing} ]]; then
634 echo
635 eerror "Flags marked with an * are missing."
636 die "Missing USE flags found"
637 fi
638} 748}
639 749
640# @FUNCTION: qt_mkspecs_dir 750# @FUNCTION: qt_mkspecs_dir
641# @RETURN: the specs-directory w/o path 751# @RETURN: the specs-directory w/o path
642# @DESCRIPTION: 752# @DESCRIPTION:
643# Allows us to define which mkspecs dir we want to use. 753# Allows us to define which mkspecs dir we want to use.
644qt_mkspecs_dir() { 754qt_mkspecs_dir() {
645 # Allows us to define which mkspecs dir we want to use.
646 local spec 755 local spec=
647
648 case ${CHOST} in 756 case ${CHOST} in
649 *-freebsd*|*-dragonfly*) 757 *-freebsd*|*-dragonfly*)
650 spec="freebsd" ;; 758 spec=freebsd ;;
651 *-openbsd*) 759 *-openbsd*)
652 spec="openbsd" ;; 760 spec=openbsd ;;
653 *-netbsd*) 761 *-netbsd*)
654 spec="netbsd" ;; 762 spec=netbsd ;;
655 *-darwin*) 763 *-darwin*)
764 if use aqua; then
765 # mac with carbon/cocoa
766 spec=macx
767 else
768 # darwin/mac with x11
656 spec="darwin" ;; 769 spec=darwin
770 fi
771 ;;
772 *-solaris*)
773 spec=solaris ;;
657 *-linux-*|*-linux) 774 *-linux-*|*-linux)
658 spec="linux" ;; 775 spec=linux ;;
659 *) 776 *)
660 die "Unknown CHOST, no platform choosen." 777 die "Unknown CHOST, no platform chosen"
661 esac 778 esac
662 779
663 CXX=$(tc-getCXX) 780 CXX=$(tc-getCXX)
664 if [[ ${CXX/g++/} != ${CXX} ]]; then 781 if [[ ${CXX} == *g++* ]]; then
665 spec="${spec}-g++" 782 spec+=-g++
666 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 783 elif [[ ${CXX} == *icpc* ]]; then
667 spec="${spec}-icc" 784 spec+=-icc
668 else 785 else
669 die "Unknown compiler ${CXX}." 786 die "Unknown compiler '${CXX}'"
670 fi 787 fi
671 if [[ -n "${LIBDIR/lib}" ]]; then 788
672 spec="${spec}-${LIBDIR/lib}" 789 # Add -64 for 64bit profiles
790 if use x64-freebsd ||
791 use amd64-linux ||
792 use x64-macos ||
793 use x64-solaris ||
794 use sparc64-solaris
795 then
796 spec+=-64
673 fi 797 fi
674 798
675 echo "${spec}" 799 echo "${spec}"
676} 800}
677 801
678case ${EAPI:-0} in 802# @FUNCTION: qt_assistant_cleanup
679 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;; 803# @INTERNAL
804# @DESCRIPTION:
805# Tries to clean up tools.pro for qt-assistant ebuilds.
806# Meant to be called in src_prepare().
807# Since Qt 4.7.4 this function is a no-op.
808qt_assistant_cleanup() {
809 # apply patching to qt-assistant ebuilds only
810 [[ ${PN} != "qt-assistant" ]] && return
811
812 # no longer needed for 4.7.4 and later
813 version_is_at_least "4.7.4" && return
814
815 # different versions (and branches...) may need different handling,
816 # add a case if you need special handling
817 case "${MY_PV_EXTRA}" in
818 *kde-qt*)
819 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
820 -e "/mac/,/^embedded.*makeqpf$/d" \
821 -i tools/tools.pro || die "patching tools.pro failed"
822 ;;
823 *)
824 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
825 -e "/mac/,/^embedded.*makeqpf$/d" \
826 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
827 -i tools/tools.pro || die "patching tools.pro failed"
828 ;;
829 esac
830}
831
832# @FUNCTION: qt_nolibx11
833# @INTERNAL
834# @DESCRIPTION:
835# Ignore X11 tests for packages that don't need X libraries installed.
836qt_nolibx11() {
837 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
838 die "x11 check sed failed"
839}
840
680 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 841EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst
681esac

Legend:
Removed from v.1.49  
changed lines
  Added in v.1.118

  ViewVC Help
Powered by ViewVC 1.1.20